<?php
function current_millis() {
    list($usec, $sec) = explode(" ", microtime());
    return round(((float)$usec + (float)$sec) * 1000);
    }
    $testTime1 = current_millis();
    $custId = 1;
    $sevenDaysAgoDay = ltrim(date('d', strtotime('-7 days')), '0');
    $sevenDaysAgoMonth = ltrim(date('m', strtotime('-7 days')), '0');
    $month = ltrim(date('m'), '0');
    $day = ltrim(date('d'), '0');
    $lastDayOfMonth = date('d',mktime(0, 0, 0, (date('m') + 1), 0, date('Y')));
    $norske_maaneder = array(1 => "januar", "februar", "mars", "april",
    "mai", "juni", "juli", "august", "september", "oktober", "november",
    "desember");
    $monthName = $norske_maaneder[$month];
    $hour = ltrim(date('H'), '0');
    $currentPrice = round(PriceTable::getCurrentPrice(), 2);
    $usage = MeterDataTable::getCurrentUsage($custId);
    $aDayAgo = date('Y-m-d 00:00:00');
    $sevenDaysAgo = date('Y-m-d H:i:s', strtotime('-7 days'));
    $aMonthAgo = date('Y-m-d H:i:s', strtotime('-1 months'));
    $firstOfMonth = date('Y-m-d H:i:s',strtotime('+0 second',strtotime(date('m').'/01/'.date('Y').' 00:00:00')));
    $lastYear = date('Y') - 1;
    $aMonthAgoLastYear  = $lastYear."-".date('m-d H:i:s', strtotime('-1 months'));
    $thisDayLastYear = $lastYear."-".date("m-d H:i:s");
    $now = date("Y-m-d H:i:s");
    $usagePastDay = MeterDataTable::getExpenditureInTimePeriod($custId, $aDayAgo, $now);
    $usagePastSevenDays = MeterDataTable::getExpenditureInTimePeriod($custId, $sevenDaysAgo, $now);
    $usageThisMonth = MeterDataTable::getExpenditureInTimePeriod($custId, $firstOfMonth, $now);
    $averageUsagePastDay = round($usagePastSevenDays/7,2);
    $predictedUsageThisMonth = MeterDataTable::getPredictedExpenditureForTimePeriod($custId, $now, date('Y'."-".$month."-".$lastDayOfMonth." 23:59:59")) + $usageThisMonth;
    $usageLastThirtyDaysLastYear = MeterDataTable::getExpenditureInTimePeriod($custId, $aMonthAgoLastYear, $thisDayLastYear);
    $usageLastThirtyDays = MeterDataTable::getExpenditureInTimePeriod($custId, $aMonthAgo, $now);
    $differenceInUsageFromLastYear = MeterDataTable::findDifferenceInExpenditure($usageLastThirtyDays, $usageLastThirtyDaysLastYear);
    if($differenceInUsageFromLastYear != "veldig mye")
    {
        
    }
    $lastYearStart = date($firstOfMonth, strtotime('-1 years'));
    $lastYearEnd = date('Y-m-d H:i:s', strtotime('-1 year'));
?>

<div id="firstRow">
    
    <div id="leftBox" class="roundedCorners">Ditt forbruk nå:<br /><div id="leftInner" class="roundedCornersInside"><?php echo $usage?> W</div>
        <div id="getPowerButton"><a id="powerButton"class="ovalbutton" href="#" onclick="pollForMeterData();" style="margin-left: 36px; margin-top: 10px;"><span>Hent effekt nå</span></a></div>
    </div>
    <div id="middleBox" class="roundedCorners">Pris akkurat nå (kl. <?php echo $hour ?>)<br /><div id="middleInner" class="roundedCornersInside"><?php echo $currentPrice ?> øre/kWh</div></div>
    
</div>

<div id="consumptionColoumn">
    <div style="margin-top: -25px; float: right; margin-right: 230px; font-size: 16px; font-weight: bold;">Hittil denne måneden</div>
<div id="firstConsRow">
    <div id="rightBox" class="roundedCorners"><div class="descriptive">Hittil i <?php echo $monthName?></div><?php echo $usageThisMonth ?> kr.
        <!--<div id="compareLastYear" class="roundedCornersInside"><?php if($compareLastYear >= 1) echo '&uarr;'; else echo '&darr;'; ?> </div>-->
    </div>
    <span id="cal" class="cal m<?php echo $month ?> d1"><span class="m2 m"></span><span class="d"></span></span>
    <span id="cal" class="cal m<?php echo $month ?> d<?php echo $day ?>" style="clear: right;"><span class="m2 m"></span><span class="d"></span></span>
</div>
    <div style="margin-top: -25px; font-size: 16px; font-weight: bold; clear:right; float: right; margin-right: 250px;">Hele måneden</div>
<div id="secondConsRow">
    <div style="float: left;">
    <span id="cal" class="cal m<?php echo $month ?> d1"><span class="m2 m"></span><span class="d"></span></span>
        <span id="cal" class="cal m<?php echo $month ?> d<?php echo $lastDayOfMonth ?>" style="clear:right;"><span class="m2 m"></span><span class="d"></span></span>
    </div>
    <div id="predictionMonth" style="float: right;" class="roundedCorners"><div class="descriptive">Anslått regning <?php echo $monthName?></div><?php echo $predictedUsageThisMonth ?> kr.</div>
</div>
    <div id="thirdConsRow">
        <div id="rightBox_3" class="roundedCorners">
            <div class="descriptive">Forbruk siste 30 dager</div>
                <?php echo $usageLastThirtyDays ?>  kr.
                <div class="descriptive" style="margin-top: 10px">
                    Tilsvarende i fjor
                </div><?php echo $usageLastThirtyDaysLastYear ?> kr.
                <div class="descriptive" style="margin-top: 10px">
                    Dette er en <?php echo $differenceInUsageFromLastYear >= 0 ? "økning" : "reduksjon"?> på
                </div><?php echo abs($differenceInUsageFromLastYear) . " %" ?>
                <br />
                <span style="font-size: smaller; text-align: right;"><?php echo link_to('Se mer', 'content/comparePeriods') ?></span>
        </div>
    </div>
    <div style="float: right; clear: right; margin-right: 255px; font-size: 16px; font-weight: bold;">I dag</div>
    <div id="todayRow">
        <div id="rightBox_4" class="roundedCorners"><div class="descriptive">I dag</div><?php echo $usagePastDay ?>  kr.</div>
        <span id="cal_today" class="cal m<?php echo $month ?> d<?php echo $day ?>"><span class="m2 m"></span><span class="d"></span></span>
    </div>
</div>
<div id="graphSpacer"></div>
<div id="categoryChooser">
    <div class="categoryRounded categoryChosen" id="consumption" onclick="changeCategory(0);changeGraphType(0);">Forbruk</div>
    <div class="categoryRounded" id="price" onclick="changeCategory(1);changeGraphType(0);">Pris</div>
</div>
<div style="text-align: center; font-size: larger; margin-top: 230px; clear: left; "><label id="graphHeader" style="border: 1px solid; padding: 5px;"><span id="graphDescription"></span><span id="graphTimeDescription"></span></label></div>
<div id="placeholder" style="width:540px;height:270px;"></div>
<div id="xAxisDescription" style="margin-left: 250px; float: left; margin-top: 10px;"></div>
<div  style="float: right; margin-top: 10px; margin-left: 0px;">
    <span onclick="changeGraphType(0);$('#radio0').attr('checked', 'checked');"><input type="radio" id="radio0" name="group1" value="0" checked><span id="graphType1"></span></span>
    <br />
    <span onclick="changeGraphType(1);$('#radio1').attr('checked', 'checked');"><input type="radio" id="radio1" name="group1" value="1"><span id="graphType2"></span></span>
    <br /><span onclick="tempOnOff();changeGraphType(graphType);"id="temperatureOnOff"></span>
</div>

<div id="timeChooser">
    <div class="hoursRounded" onclick="drawNewGraph(24);">24 t.</div>
    <div class="hoursRounded" onclick="drawNewGraph(168);">1 uke</div>
    <div class="hoursRounded" onclick="drawNewGraph(729);">1 mnd.</div>
</div>
<?php echo javascript_include_tag("mainGraphs.js"); ?>