/*
 * All the JavaScript for displaying the graphing data on the main page ("Hjem").
 * Lots of Flot usage and AJAX-calls for fetching the data.
 */

var temp1 = [];
var temp2 = [];
var temp3 = [];
var temps = [temp1, temp2, temp3];
var consBar1 = [];
var consBar2 = [];
var consBar3 = [];
var consLine1 = [];
var consLine2 = [];
var consLine3 = [];
var consLines = [consLine1, consLine2, consLine3];
var priceFut1 = [];
var priceFut2 = [];
var priceFut3 = [];
var priceFuts = [priceFut1, priceFut2, priceFut3];
var pricePast1 = [];
var pricePast2 = [];
var pricePast3 = [];
var pricePasts = [pricePast1, pricePast2, pricePast3];
var consBars = [consBar1, consBar2, consBar3];

$.ajax({
         type: "POST",
         url: "content/FetchAllAvailableInformation",
         dataType: "json",
         async: false,
         success: function(results){
             populateData(results);
          },
         error: function(a){
             console.log(a);
         }
    });
    changeCategory(0);
    var category = 0;
    var hours = 24;
    var interval = 60;
    var defaultGraphType = ["Stolpediagram", "Kontinuerlig"];
    var graphType = 0;
    var lightGreen = "#88aa88";
    var lightBlue = "#0f90c6";
    var darkGreen = '#166834';
    var lightRed = '#d6433e';
    var blue = 'blue';
    var tempOn = false;
    changeGraphType(0);

function populateData(results)
{
    var j = 0;
    if(results[j].length > 0)
    {
        var previous = results[j][0][1];
        var current = results[j][0][1];
        for (var i = 0; i < results[j].length; i ++){
            current = results[j][i][1] - previous;
            previous = results[j][i][1];
            consBar1.push([results[j][i][0], current]);
        }
    }
     j++;
     if(results[j].length > 0)
     {
        previous = results[j][0][1];
        current = results[j][0][1];
        for (var i = 0; i < results[j].length; i ++){
            current = results[j][i][1] - previous;
            previous = results[j][i][1];
            consBar2.push([results[j][i][0], current]);
        }
     }
     j++;
     if(results[j].length > 0)
     {
        previous = results[j][0][1];
        current = results[j][0][1];
        for (var i = 0; i < results[j].length; i ++){
            current = results[j][i][1] - previous;
            previous = results[j][i][1];
            consBar3.push([results[j][i][0], current]);
        }
     }
     j++;
     var first = 0;
     if(results[j].length > 0)
     {
         first = results[j][0][1];
         for (i = 0; i < results[j].length; i ++)
            consLine1.push([results[j][i][0], results[j][i][1] - first]);
     }
     j++;
     if(results[j].length > 0)
     {
         first = results[j][0][1];
         for (i = 0; i < results[j].length; i ++)
            consLine2.push([results[j][i][0], results[j][i][1] - first]);
     }
     j++;
     if(results[j].length > 0)
     {
         first = results[j][0][1];
         for (i = 0; i < results[j].length; i ++)
            consLine3.push([results[j][i][0], results[j][i][1] - first]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            priceFut1.push([results[j][i][0], results[j][i][1]]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            priceFut2.push([results[j][i][0], results[j][i][1]]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            priceFut3.push([results[j][i][0], results[j][i][1]]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            pricePast1.push([results[j][i][0], results[j][i][1]]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            pricePast2.push([results[j][i][0], results[j][i][1]]);
     }
     j++;
     if(results[j].length > 0)
     {
         for (i = 0; i < results[j].length; i ++)
            pricePast3.push([results[j][i][0], results[j][i][1]]);
     }
}

$.ajax({
         type: "POST",
         url: "content/temperatureInformation",
         dataType: "json",
         success: function(results){
             var j = 0;
             for (i = 0; i < results[j].length; i ++)
                temp1.push([results[j][i]["time"], results[j][i]["temperature"]]);
             j++;
             for (i = 0; i < results[j].length; i ++)
                temp2.push([results[j][i]["time"], results[j][i]["temperature"]]);
             j++;
             for (i = 0; i < results[j].length; i ++)
                temp3.push([results[j][i]["time"], results[j][i]["temperature"]]);
             j++;
          },
         error: function(a){
             console.log(a);
         }
    });

var timeoutSet = false;
function pollForMeterData()
{
    $("#leftInner").fadeTo('slow', 0.2, null);
    $.ajax({
         type: "POST",
         url: "content/pollMeter",
         dataType: "json",
         success: function(results){
             if(results.substr(0, 3) != "NOK")
             {
                 $("#leftInner").fadeTo('slow', 1, null);
                 $("#leftInner").html('');
                 $("#leftInner").html(results + ' W');
                 $("#powerButton").removeClass("ovalbutton");
                 $("#powerButton").removeClass("ovalbuttonError");
                 $('#powerButton').addClass("ovalbuttonDeac");
                 timeoutSet = true;
                 setTimeout("activatePowerButton();", 60000);
             }
             else
             {
                 if(!timeoutSet)
                 {
                     timeoutSet = true;
                     setTimeout("activatePowerButton();", results.substr(3, results.length - 2))
                 }
                 $("#leftInner").fadeTo('slow', 1, null);
                 $("#powerButton").removeClass("ovalbutton");
                 $("#powerButton").removeClass("ovalbuttonError");
                 $('#powerButton').addClass("ovalbuttonDeac");
             }
          },
         error: function(a){
             if(!timeoutSet)
                 {
                     timeoutSet = true;
                     setTimeout("activatePowerButton();", 30000);
                 }
                 $("#leftInner").fadeTo('slow', 1, null);
                 $("#powerButton").removeClass("ovalbutton");
                 $('#powerButton').addClass("ovalbuttonError");
         }
    });
}

function activatePowerButton()
{
    $("#powerButton").removeClass("ovalbuttonDeac");
    $("#powerButton").removeClass("ovalbuttonError");
    $("#powerButton").addClass("ovalbutton");
    timeoutSet = false;
}
function getSelectedGraphValue()
{
    var sel = document.getElementById("selectTagId");
    return sel.options[sel.selectedIndex].value;
}

function drawNewGraph(hoursIn)
{
    hours = hoursIn;
    if(category == 0 && graphType == 0)
    {
        getConsumptionInformationBarChart(hours, interval);
        changeTimeInfoBGColor(lightGreen, darkGreen, hours);
    }
    else if(category == 0 && graphType == 1)
    {
        getConsumptionInformation(hours);
        changeTimeInfoBGColor(lightGreen, darkGreen, hours);
    }
    else
    {
        getPriceInformation(hours, graphType);
        changeTimeInfoBGColor('#0f90c6', 'blue', hours);
    }
}

function changeGraphType(val){
    if(val == 0 && category == 0)
    {
        graphType = 0;
        getConsumptionInformationBarChart(hours, interval)
    }
    else if(val == 0 && category == 1)
    {
        graphType = 0;
        getPriceInformation(hours, graphType);
        graphType == 0 ? $("#graphDescription").html("Strømpris kommende ") : $("#graphDescription").html("Strømpris forrge ");
        $("#temperatureOnOff").show();
    }
    else if(val == 1 && category == 0)
    {
        graphType = 1;
        getConsumptionInformation(hours);
    }
    else if(val == 1 && category == 1)
    {
        graphType = 1;
        getPriceInformation(hours, graphType);
        graphType == 0 ? $("#graphDescription").html("Strømpris kommende ") : $("#graphDescription").html("Strømpris forrige ");
        $("#temperatureOnOff").hide();
    }
    //$('#radio'+graphType).attr("checked","checked");
    var img1 = "<img id='barGraphPic' height=25px' src='/images/bargraph.png'/>";
    var img2 = "<img id='lineGraphPic' height=25px' src='/images/linegraph.png'/>";
    var future = "Fremtid";
    var past = "Fortid";
    if(category == 0){
        $("#graphType1").html(""+img1);
        $("#graphType2").html(img2);
    }
    if(category == 1){
        $("#graphType1").html(future);
        $("#graphType2").html(past);
    }
}

function getConsumptionInformationBarChart(hours, interval)
{
category = 0;
var stack = 0, bars = true, lines = false, steps = false;
    var options = {
            series: {
                stack: stack,
                lines: {show: lines, steps: steps},
                bars: {show: bars, barWidth : interval*60*1000}
            },
            yaxis: {tickFormatter: function (v, axis) {return '<span style="color:'+darkGreen+ ';">' + v.toFixed(axis.tickDecimals) +" kWh</span>"}}
        };

    changeTimeInfoBGColor(lightGreen, darkGreen, hours);
    labelXAxis(hours, options);
    var index = findRightIndex(hours);
    var content = {label: "kWh", color: "#166834", data: consBars[index]};
      $.plot($("#placeholder"), [ content ], options);
}
var monthnames = ["jan", "feb", "mar", "apr", "mai", "jun", "jul", "aug", "sep", "okt", "nov", "des"];
function labelXAxis(hours, options)
{
if(hours < 25){
    $("#xAxisDescription").html("Klokkeslett");
    $("#graphTimeDescription").html("24 timer");
    $.extend(true, options, {xaxis: {mode: "time", timeformat: "%h:%M", monthNames: monthnames}});
}
else if(hours < 169){
    $("#xAxisDescription").html("Dato");
    $("#graphTimeDescription").html("syv dager");
    $.extend(true, options, {xaxis: {mode: "time", timeformat: "%d.%b", monthNames: monthnames}});
}
else{
    $("#xAxisDescription").html("Dato");
    $("#graphTimeDescription").html("30 dager");
    $.extend(true, options, {xaxis: {mode: "time", timeformat: "%d.%b", monthNames: monthnames}});
}
}
function getConsumptionInformation(hours){
    category = 0;
    changeTimeInfoBGColor(lightGreen, darkGreen, hours);
    var index = findRightIndex(hours);
    var content = {label: "kWh", color: "#166834", data: consLines[index]}
        var options = {lines: {steps: false},
                               yaxis: {tickFormatter: function (v, axis) {return '<span style="color:'+ darkGreen + ';">' + v.toFixed(axis.tickDecimals) +" kWh</span>"}}};
        labelXAxis(hours,options);
        $.plot($("#placeholder") , [content], options);
}
function changeTimeInfoBGColor(baseColor, chosenColor, hours){
    $('.hoursRounded').css('background-color', baseColor);
    if(hours < 25){
        $('.hoursRounded:first').css('background-color', chosenColor);
    }
    else if(hours < 169){
        $('.hoursRounded:odd').css('background-color', chosenColor);
    }
    else{
        $('.hoursRounded:last').css('background-color', chosenColor);
    }
}



function getPriceInformation(hours, backInTime){
    category = 1;
    changeTimeInfoBGColor('#0f90c6', 'blue', hours);
    if(backInTime)
    {
        var index = findRightIndex(hours);
        var content = {label: "øre/kWh", color: blue, data: pricePasts[index]};
                var options = {lines: {steps: true},
                               yaxis: {tickFormatter: function (v, axis) {return '<span style="color:'+ blue + ';">' + v.toFixed(axis.tickDecimals) +" øre</span>"}}};
                labelXAxis(hours,options);
                $.plot($("#placeholder") , [content], options);
    }
    else{
        drawPricesAndTemperature(hours);
    }
}

function findRightIndex(hours)
{
    var index;
    switch(hours){
    case 24:
        index = 0;
        break;
    case 168:
        index = 1;
        break;
    default:
        index = 2;
        break;
    }
    return index;
}

function drawPricesAndTemperature(hours){
var content;
var content2 = [];
var lightBlue = "#0f90c6";
var index = findRightIndex(hours);
if(tempOn){
    content2 = {label: "°C", color: lightRed, yaxis: 2, data: temps[index], lines: {show: true, steps: false}}
}
content = {label: "øre/kWh", color: "#0f90c6", data: priceFuts[index], lines: {show: true, steps: true}}
var options = {yaxis: {tickFormatter: function (v, axis) {return '<span style="color:'+lightBlue + ';">' + v.toFixed(axis.tickDecimals) +" øre</span>"}},
            y2axis: {tickFormatter: function (v, axis) {return '<span style="color:' + lightRed + '">' + v.toFixed(axis.tickDecimals) +" °C</span>"}}};
labelXAxis(hours,options);
$.plot($("#placeholder") , [content,content2], options);
}

function changeCategory(cat)
{
    $("#temperatureOnOff").html('');
    if(cat == 0){
        category = 0;
        $("#graphHeader").css("color", "green");
        $("#graphDescription").html("Ditt forbruk siste ");
        $("#consumption").addClass('categoryChosen');
        $("#price").removeClass('categoryChosen');

    }
    else if(cat == 1){
        category = 1;
        $("#graphHeader").css("color", "#0f90c6");
        $("#price").addClass('categoryChosen');
        $("#consumption").removeClass('categoryChosen');
        $("#temperatureOnOff").html('<input type="checkbox" id="tempCheckbox" />Temperatur');
        var check = tempOn ? 'checked' : '';
        $("#tempCheckbox").attr('checked', check);
    }
    $("#radio0").attr('checked', 'checked');
}
function tempOnOff()
{
    tempOn = tempOn ? false : true;
    var check = tempOn ? 'checked' : '';
    $("#tempCheckbox").attr('checked', check);
}