package data;
import crypto.*;
import data.Helper;
public class HDLCData {
	public static byte[] getActivePower = Helper.hexStringToByteArray("7EA0190321326FD8E6E600C0018100030101010700FF02001E507E");
	public static byte[] getMeterType = Helper.hexStringToByteArray("7EA0190321326FD8E6E600C0018100030101010700FF02001E507E");
	public static String METER_TYPE_OBIS_CODE = "0101600101FF";
	public static String VOLTAGE_L3_OBIS_CODE = "0101481900FF";
	public static byte[] getGetRequest(String obisCode)
	{
//																C0018100030101481900FF0200
		return Helper.hexStringToByteArray("7EA0190321326FD8E6E600C001810003" + obisCode + "02001E507E");
	}
	public static byte[] getGetRequestDataClass(String obisCode)
	{
		return Helper.hexStringToByteArray("7EA0190321326FD8E6E600C00181000F" + obisCode + "02001E507E");
	}
	public static byte[] associationRequestNoSecurity = Helper.hexStringToByteArray("7EA02B032110FBAFE6E600601DA109060760857405080101BE10040E01000000065F1F040000FC1FFFFF81DC7E");
																	//7EA0190321326FD8E6E600
	public static byte[] openHdlcConnection = Helper.hexStringToByteArray("7EA0070321930F017E");
	public static void main(String[] args) {
		System.out.println(getActivePower.length);
		System.out.println(associationRequestNoSecurity.length);
		System.out.println(openHdlcConnection.length);
	}
}
