package net;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.SocketAddress;

import crypto.Test;
import data.MessageTypes;
import data.XMLParser;

public class DatagramClient {
	public static int port = 4059;
	public static void main(String[] args) {
		DatagramSocket socket = null;
		byte[] getRequestApdu = XMLParser.xmlToPdu(MessageTypes.ASSOCIATION_REQUEST);
		String apdu = Test.getHexString(getRequestApdu);
		String wrapper = "000100100001001F";
		String msgToSend = wrapper + apdu;
		
		byte[] msg = Test.hexStringToByteArray(msgToSend);
		byte[] receive = new byte[2000];
		try {
			InetAddress addr = InetAddress.getByName("strommaler.item.ntnu.no");
			socket = new DatagramSocket();
			socket.connect(addr, port);
			System.out.println(socket.getInetAddress().getHostAddress());
			System.out.println("Port: " + socket.getLocalPort() + " Address: " + socket.getLocalAddress().getHostAddress());
			DatagramPacket packet = new DatagramPacket(msg, msg.length, 
                    addr, port);
			socket.send(packet);
			util.Print.ciphertext(msg);
			System.out.println("Sent packet" + packet.getLength() + " - ");
			DatagramPacket receivePacket = new DatagramPacket(receive, receive.length);
			socket.receive(receivePacket);
			util.Print.ciphertext(receive);
		} catch (Exception e) {
			// TODO: handle exception
		}
	}
}
