package data;

import crypto.Test;

public class MessageTypes {
	public static String ASSOCIATION_REQUEST_LO_LO = "<AssociationRequest>"
		+ "<ApplicationContextName Value='LN'/>"
		+ "<SenderACSERequirements Value='1'/>"
		+ "<MechanismName Value='LOW_SECURITY'/>"
		+ "<CallingAuthenticationValue Value='3039' />"
		+ "<InitiateRequest>"
		+ "<ProposedDlmsVersionNumber Value='06'/>"
		+ "<ProposedConformance>"
		+ "<ConformanceBit Name='Action'/>"
		+ "<ConformanceBit Name='EventNotification'/>"
		+ "<ConformanceBit Name='SelectiveAccess'/>"
		+ "<ConformanceBit Name='Set'/>"
		+ "<ConformanceBit Name='Get'/>"
		+ "<ConformanceBit Name='BlockTransferWithAction'/>"
		+ "<ConformanceBit Name='BlockTransferWithSet'/>"
		+ "<ConformanceBit Name='BlockTransferWithGet'/>"
		+ "<ConformanceBit Name='Attribute0SupportedWithGet'/>"
		+ "<ConformanceBit Name='PriorityMgmtSupported'/>"
		+ "<ConformanceBit Name='Attribute0SupportedWithSet'/>"
		+ "</ProposedConformance>"
		+ "<ProposedMaxPduSize Value='FFFF'/>"
		+ "</InitiateRequest>"
		+ "</AssociationRequest>";
	public static String ASSOCIATION_REQUEST = "<AssociationRequest>"
	+ "<ApplicationContextName Value='LN'/>"
	+ "<InitiateRequest>"
	+ "<ProposedDlmsVersionNumber Value='06'/>"
	+ "<ProposedConformance>"
	+ "<ConformanceBit Name='Action'/>"
	+ "<ConformanceBit Name='EventNotification'/>"
	+ "<ConformanceBit Name='SelectiveAccess'/>"
	+ "<ConformanceBit Name='Set'/>"
	+ "<ConformanceBit Name='Get'/>"
	+ "<ConformanceBit Name='BlockTransferWithAction'/>"
	+ "<ConformanceBit Name='BlockTransferWithSet'/>"
	+ "<ConformanceBit Name='BlockTransferWithGet'/>"
	+ "<ConformanceBit Name='Attribute0SupportedWithGet'/>"
	+ "<ConformanceBit Name='PriorityMgmtSupported'/>"
	+ "<ConformanceBit Name='Attribute0SupportedWithSet'/>"
	+ "</ProposedConformance>"
	+ "<ProposedMaxPduSize Value='FFFF'/>"
	+ "</InitiateRequest>"
	+ "</AssociationRequest>";
	public static String ASSOCIATION_REQUEST_LOW_SECURITY = "<AssociationRequest>"
	+ "<ApplicationContextName Value='LN'/>"
	+ "<SenderACSERequirements Value='01'/>"
	+ "<MechanismName Value='LOW_SECURITY'/>"
	+ "<CallingAuthenticationValue Value='3039'/>"
	+ "<InitiateRequest>"
	+ "<ProposedDlmsVersionNumber Value='06'/>"
	+ "<ProposedConformance>"
	+ "<ConformanceBit Name='Action'/>"
	+ "<ConformanceBit Name='SelectiveAccess'/>"
	+ "<ConformanceBit Name='Set'/>"
	+ "<ConformanceBit Name='Get'/>"
	+ "<ConformanceBit Name='BlockTransferWithGet'/>"
	+ "<ConformanceBit Name='Attribute0SupportedWithGet'/>"
	+ "</ProposedConformance>"
	+ "<ProposedMaxPduSize Value='00FF'/>"
	+ "</InitiateRequest>"
	+ "</AssociationRequest>";
	public static String GET_REQUEST_NORMAL_CLOCK = "<GetRequest><GetRequestNormal><InvokeIdAndPriority Value='81'/><AttributeDescriptor><ClassId Value='0008'/><InstanceId Value='0000010000FF'/><AttributeId Value='02'/></AttributeDescriptor></GetRequestNormal></GetRequest>";
	public static String GET_REQUEST_ACTIVE_POWER = "<GetRequest>"
	+ "<GetRequestNormal>"
	+ "<InvokeIdAndPriority Value='81'/>"
	+ "<AttributeDescriptor>"
	+ "<ClassId Value='0003'/>"
	+ "<InstanceId Value='0101010700FF'/>"
	+ "<AttributeId Value='02'/>"
	+ "</AttributeDescriptor>"
	+ "</GetRequestNormal>"
	+ "</GetRequest>";
	public static String GET_REQUEST_VOLTAGE_L3 = "<GetRequest>"
		+ "<GetRequestNormal>"
		+ "<InvokeIdAndPriority Value='81'/>"
		+ "<AttributeDescriptor>"
		+ "<ClassId Value='0003'/>"
		+ "<InstanceId Value='0101481900FF'/>"
		+ "<AttributeId Value='02'/>"
		+ "</AttributeDescriptor>"
		+ "</GetRequestNormal>"
		+ "</GetRequest>";
	public static String GET_REQUEST_ACTIVE_POWER_P23 = "<GetRequest>"
		+ "<GetRequestNormal>"
		+ "<InvokeIdAndPriority Value='81'/>"
		+ "<AttributeDescriptor>"
		+ "<ClassId Value='0003'/>"
		+ "<InstanceId Value='0101020700FF'/>"
		+ "<AttributeId Value='02'/>"
		+ "</AttributeDescriptor>"
		+ "</GetRequestNormal>"
		+ "</GetRequest>";
	public static String GET_REQUEST_OBJECTS = "<GetRequest>"
		+ "<GetRequestNormal>"
		+ "<InvokeIdAndPriority Value='81'/>" // 81 = 1100 0001
		+ "<AttributeDescriptor>"
		+ "<ClassId Value='000F'/>"
		+ "<InstanceId Value='0000280000FF' />"
		+ "<AttributeId Value='02'/>"
		+ "</AttributeDescriptor>"
		+ "</GetRequestNormal>"
		+ "</GetRequest>";
	public static String GET_REQUEST_METER_TYPE = "<GetRequest>"
		+ "<GetRequestNormal>"
		+ "<InvokeIdAndPriority Value='81'/>" // 81 = 1100 0001
		+ "<AttributeDescriptor>"
		+ "<ClassId Value='0001'/>"
		+ "<InstanceId Value='0101600101FF' />"
		+ "<AttributeId Value='02'/>"
		+ "</AttributeDescriptor>"
		+ "</GetRequestNormal>"
		+ "</GetRequest>";
	public static String ASSOCIATION_REQUEST_HIGH_SECURITY = "<AssociationRequest>"
	  + "<ApplicationContextName Value='LN' />"
	  + "<SenderACSERequirements Value='1' />"
	  + "<MechanismName Value='HIGH_SECURITY' />"
	  + "<CallingAuthenticationValue Value='5F5F444C4D532D4578706C6F7265725F' />"
	  + "<InitiateRequest>"
	    + "<ProposedDlmsVersionNumber Value='06' />"
	    + "<ProposedConformance>"
	      + "<ConformanceBit Name='Action' />"
	      + "<ConformanceBit Name='SelectiveAccess' />"
	      + "<ConformanceBit Name='Set' />"
	      + "<ConformanceBit Name='Get' />"
	      + "<ConformanceBit Name='BlockTransferWithSet' />"
	      + "<ConformanceBit Name='BlockTransferWithGet' />"
	    + "</ProposedConformance>"
	    + "<ProposedMaxPduSize Value='FFFF' />"
	  + "</InitiateRequest>"
	+ "</AssociationRequest>";
	public static String ACTION_REQUEST_REPLY_TO_HLS_AUTHENTICATION = "<ActionRequest>"
	  + "<ActionRequestNormal>"
	    + "<InvokeIdAndPriority Value='C1' />"
	    + "<MethodDescriptor>"
	      + "<ClassId Value='000F' />"
	      + "<InstanceId Value='0000280000FF' />"
	      + "<MethodId Value='01' />"
	    + "</MethodDescriptor>"
	    + "<MethodInvocationParameters>"
	      + "<OctetString Value='7F75F091C9D0F70B3BD94E8A4962BA16' />"
	    + "</MethodInvocationParameters>"
	  + "</ActionRequestNormal>"
	+ "</ActionRequest>";
	public static String getGetRequestNormal(String classId, String instanceId)
	{
		return "<GetRequest>"
		+ "<GetRequestNormal>"
		+ "<InvokeIdAndPriority Value='81'/>"
		+ "<AttributeDescriptor>"
		+ "<ClassId Value='"+ classId +"'/>"
		+ "<InstanceId Value='"+ instanceId +"'/>"
		+ "<AttributeId Value='02'/>"
		+ "</AttributeDescriptor>"
		+ "</GetRequestNormal>"
		+ "</GetRequest>";
	}
	public static String GET_REQUEST_NEXT_BLOCK = "<GetRequest>"
	+ "<GetRequestForNextDataBlock>"
	+ "<InvokeIdAndPriority Value='81'/>"
	+ "<BlockNumber Value='00000001'/>"
	+ "</GetRequestForNextDataBlock>"
	+ "</GetRequest>";
	public static String getNextGetRequest(byte[] counter)
	{
		return "<GetRequest>"
		+ "<GetRequestForNextDataBlock>"
		+ "<InvokeIdAndPriority Value='81'/>"
		+ "<BlockNumber Value='" + Helper.getHexString(counter) + "'/>"
		+ "</GetRequestForNextDataBlock>"
		+ "</GetRequest>";
	}
}
