package crypto;
import java.io.UnsupportedEncodingException;

import icube.xmlpdu.XmlPduInterface;
import icube.xmlpdu.b.e;
import util.*;
import data.Helper;

public class Test {
	public static void main(String[] args) {
		MessageProtecter m = new GCM();
		long c = System.currentTimeMillis();
		byte[] a, b;
		byte[] asdf = Helper.hexStringToByteArray("C104810200010000800000FF020000010000800100FF020002093201020304050607080910111213141516171819202122232425262728293031323334353637383940414243444546474849500A03303030");
		try {
			byte[] authenticatedData = new byte[]{
	        		(byte) 0x30, (byte) 0xD0, (byte) 0xD1, (byte) 0xD2,
	        		(byte) 0xD3, (byte) 0xD4, (byte) 0xD5, (byte) 0xD6,
	        		(byte) 0xD7, (byte) 0xD8, (byte) 0xD9, (byte) 0xDA,
	        		(byte) 0xDB, (byte) 0xDC, (byte) 0xDD, (byte) 0xDF,
	        };
			a = m.encryptData("There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which don't look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isn't anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.".getBytes());
//			System.out.println(System.currentTimeMillis() - c);
			b = m.decryptData(a);
			System.out.println("Dekryptert: " + new String(b));
			byte[] msg = {
					(byte) 0x01, (byte) 0x01, (byte) 0x10, (byte) 0x00,
					(byte) 0x11, (byte) 0x22, (byte) 0x33,
					(byte) 0x44, (byte) 0x55, (byte) 0x66, (byte) 0x77,
					(byte) 0x88, (byte) 0x99, (byte) 0xAA, (byte) 0xBB,
					(byte) 0xCC, (byte) 0xDD, (byte) 0xEE, (byte) 0xFF,
					(byte) 0x00, (byte) 0x00, (byte) 0x06, (byte) 0x5F,
					(byte) 0x1F, (byte) 0x04, (byte) 0x00, (byte) 0x00,
					(byte) 0x7E, (byte) 0x1F, (byte) 0x04, (byte) 0xB0, 
			};
			byte[] msg2 = Helper.hexStringToByteArray("0800065F1F0400007C1F04000007");
			for (int i = 0; i < 20; i++) {
				byte[] hello = m.encryptData(msg);
				System.out.println("The ciphertext from message:\n");
				util.Print.ciphertext(hello);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
}
