package data;

import java.util.Arrays;

import com.rsa.shareTLS.x.ci;

import crypto.GCM;
import crypto.MessageProtecter;
import crypto.Test;

public class MessageHandler {
	static String asdf = "<AssociationRequest>"
	+ "<ApplicationContextName Value='LN'/>"
	+ "<SenderACSERequirements Value='1'/>"
	+ "<MechanismName Value='LOW_SECURITY'/>"
	+ "<CallingAuthenticationValue Value='4142434445464748'/>"
	+ "<InitiateRequest>"
	+ "<ProposedDlmsVersionNumber Value='06'/>"
	+ "<ProposedConformance>"
	+ "<ConformanceBit Name='Action'/>"
	+ "<ConformanceBit Name='SelectiveAccess'/>"
	+ "<ConformanceBit Name='Set'/>"
	+ "<ConformanceBit Name='Get'/>"
	+ "<ConformanceBit Name='BlockTransferWithGet'/>"
	+ "<ConformanceBit Name='Attribute0SupportedWithGet'/>"
	+ "</ProposedConformance>"
	+ "<ProposedMaxPduSize Value='FFFF'/>"
	+ "</InitiateRequest>"
	+ "</AssociationRequest>";
	public MessageHandler()
	{
		MessageProtecter m = new GCM();
		byte[] pdu = XMLParser.xmlToPdu(asdf);
		byte[] cipheredPdu = m.encryptData(pdu);
		System.out.println(new String(Test.getHexString(pdu)));
		System.out.println("Size clear: " + pdu.length);
		System.out.println(new String(Test.getHexString(cipheredPdu)));
		System.out.println("Size ciphered: " + cipheredPdu.length);
		byte[] uncipheredPdu = m.decryptData(cipheredPdu);
		System.out.println(new String(Test.getHexString(uncipheredPdu)));
		System.out.println("Size decrypted: " + uncipheredPdu.length);
		System.out.println(util.Array.equals(pdu, pdu.length, uncipheredPdu, pdu.length));
		String decryptedXml = XMLParser.pduToXml(uncipheredPdu);
		System.out.println(decryptedXml);
		System.out.println(XMLParser.getSingleValueFromElementName(decryptedXml, "MechanismName", "Value"));
//		String bcd = "0C010002020FFF1623";
//		String bcd = "0C01000600000937";
		String bcd = "050102C448";
//		String adf = "931871";
		String xml = XMLParser.pduToXml(Test.hexStringToByteArray(bcd));
		System.out.println(xml);
//		System.out.println(XMLParser.pduToXml(Test.hexStringToByteArray(adf)));
		String value = XMLParser.getSingleValueFromElementName(xml, "DoubleLongUnsigned", "Value");
		long result = 0;
		System.out.println("verdi: " + value);
		for(int i = 0; i < value.length(); i++) {
			 result = (result << 4) | Character.digit(value.charAt(i), 16);
		}
		System.out.println("verdien av tallet er: " + result);
		String ashild = "C1038101000000021F20212223242526272829303132333435363738394041424344454647484950";
		System.out.println(XMLParser.pduToXml(Test.hexStringToByteArray(ashild)));
	}

}
