package dcs;

public class Meter {
	
	private String macAddress, ipAddress;
	private int port = 1025;
	private boolean beingPolled;
	
	public Meter(String macAddr, String ipAddr)
	{
		macAddress = macAddr;
		if(ipAddr == null)
			ipAddress = "strommaler.item.ntnu.no";
		else
			ipAddress = ipAddr;
	}

	public Meter(String macAddr, String ipAddr, int port)
	{
		macAddress = macAddr;
		if(ipAddr == null)
			ipAddress = "strommaler.item.ntnu.no";
		else
			ipAddress = ipAddr;
		if(port == 0)
			this.port = 1025;
		else 
			this.port = port;
	}
	public String getMacAddress() {
		return macAddress;
	}

	public String getIpAddress() {
		return ipAddress;
	}

	public void setIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}
	
	public boolean isBeingPolled() {
		return beingPolled;
	}

	public void setBeingPolled(boolean beingPolled) {
		this.beingPolled = beingPolled;
	}
}
