package net;

import data.HDLCData;
import data.Helper;
import data.XMLParser;
import dcs.Meter;
/*
 * Brukerinitiert klient for å hente data 'on demand'.
 */
public class CustomerClient extends Client {
	private double lastActivePower;
	public double getLastActivePower() {
		return lastActivePower;
	}
	public CustomerClient(Meter m)
	{
		super(m);
	}
	protected void saveDataToDB(double activePower)
	{
		System.out.println("later som lagrer til db " + activePower);
		setLastActivePower(activePower);
	}
	public void setLastActivePower(double lastActivePower) {
		this.lastActivePower = lastActivePower;
	}
}
