package test;

import java.util.ArrayList;

import crypto.Test;
import data.DB;
import data.MessageTypes;
import data.XMLParser;
import icube.ezhdlc.EzHdlcException;
import icube.ezhdlc.EzHdlcInterface;
import icube.ezhdlc.HDLCParameters;
import icube.ezhdlc.TCPChannelParameters;
import data.Helper;

public class HDLCTest {
	public static int port = 1025;
//	public static String host = "129.241.208.75";
	public static String host = "192.168.1.104";
	public static void main(String[] args) {
		String testi = "601DA109060760857405080101BE10040E01000000065F1F0400007E1F04B0"; //"7EA02E0002002321107ECBE6E600601DA109060760857405080101BE10040E01000000065F1F040000301DFFFFD4C57E"; //
		byte[] fromServer = new byte[2000];
		byte[] toServer = XMLParser.xmlToPdu(MessageTypes.ASSOCIATION_REQUEST);
		byte[] getReq = XMLParser.xmlToPdu(MessageTypes.GET_REQUEST_OBJECTS);
		byte[] getActivePower = XMLParser.xmlToPdu(MessageTypes.GET_REQUEST_ACTIVE_POWER);
		byte[] meterType = XMLParser.xmlToPdu(MessageTypes.GET_REQUEST_METER_TYPE);
		byte[] voltage = XMLParser.xmlToPdu(MessageTypes.GET_REQUEST_VOLTAGE_L3);
		byte[] activePowerP14 = XMLParser.xmlToPdu(MessageTypes.GET_REQUEST_ACTIVE_POWER_P23);
		System.out.println("First pdu to be sent: ");
		util.Print.plaintext(toServer);
		byte[] getReqNext;
		HDLCParameters params = new HDLCParameters();
		params.ClientMACAddress = 16;
		params.ServerLowerMACAddressValue = 0;
		params.ServerUpperMACAddressValue = 1;
		params.ServerAddressSize = 1;
		params.ResponseTimeout = 10000;
		params.InactivityTimeout = 20000;
		params.InterFrameTimeOut = 500;
		params.DiscToNDMTimeout = 10000;
		
		int pduSizeTotal = 0;
		DB db = DB.getDBObject();
		EzHdlcInterface intface = null;
		TCPChannelParameters tcpParams = new TCPChannelParameters(host, port);
		while(true)
		{
		try {
			intface = new EzHdlcInterface(params, tcpParams);
			intface.connect();
			System.out.println("Got here");
			fromServer = intface.sendReceive(toServer);
			System.out.println(XMLParser.pduToXml(fromServer));
			boolean more = true;
			StringBuilder value = new StringBuilder();
//			fromServer = intface.sendReceive(meterType);
//			util.Print.plaintext(getActivePower);
			pduSizeTotal += toServer.length;
			pduSizeTotal += fromServer.length;
			value = new StringBuilder(XMLParser.getSingleValueFromElementName(XMLParser.pduToXml(fromServer), "DoubleLongUnsigned", "Value"));
			System.out.println(XMLParser.pduToXml(fromServer));
			System.out.println("Nyttedata: " + pduSizeTotal);
			double activePower = Helper.stringOfBytesToInt(value.toString(), 0);
//			db.insertActivePower(activePower);
			try {
				Thread.sleep(15000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			intface.disconnect();
			intface.dispose();
			break;
			}catch (EzHdlcException e) {
				e.printStackTrace();
			}catch (Exception e) {
				// TODO: handle exception
			}
			
//			String objectsXml = XMLParser.pduToXml(Helper.hexStringToByteArray(value));
//			System.out.println(objectsXml);
			
//			int i = 1;
//			System.out.println(XMLParser.pduToXml(fromServer));
//			while(more)
//			{
//				getReqNext = XMLParser.xmlToPdu(MessageTypes.getNextGetRequest(Helper.intToByteArray(i)));
//				i++;
//				fromServer = intface.sendReceive(getReqNext);
//				pduSizeTotal += getReqNext.length;
//				pduSizeTotal += fromServer.length;
//				value.append(XMLParser.getSingleValueFromElementName(XMLParser.pduToXml(fromServer), "RawData", "Value"));
//				more = XMLParser.getSingleValueFromElementName(XMLParser.pduToXml(fromServer), "LastBlock", "Value").equals("01") ? false : true;
//				System.out.println(XMLParser.pduToXml(fromServer));
//			}
//			String rawData = "FF"+ value.toString();
//			System.out.println("Ferdig snakka: " + rawData);
//			byte[] finalPdu = Helper.hexStringToByteArray(rawData);
//			util.Print.ciphertext(finalPdu);
//			System.out.println("XML-en: \n" + XMLParser.pduToXml(finalPdu));
//			ArrayList<String> instanceIds = XMLParser.getValuesWithElementName(XMLParser.pduToXml(finalPdu), "OctetString");
//			for (String string : instanceIds) {
//				System.out.println("\"" + string + "\",");
//			}
//			intface.disconnect();
//			System.out.println("Total nyttedata: " + pduSizeTotal);
		} 
	}

}
